<template>
  <main>
    <mt-page-title
      :link-to="profilLink({ name: 'activites-id', params: { id: activite.id }, query: { visu: visu } })"
      link-text="Retour à l'activité"
    >
      <h1 class="has-text-weight-bold is-size-3">Modification d'une activité</h1>
      <span v-if="uniteParent" class="has-text-weight-bold is-size-6 mt-grey is-uppercase"
        >Activité portée par l'unité
      </span>
      <span v-if="uniteParent" class="has-text-weight-bold is-size-6 mt-grey"> {{ unite }}</span>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-form-fields-activity
        :activite="activite"
        :effectif-previsionnel="effectifPrevisionnel"
        :pax-max="nombrePax"
        :modifier="true"
        :from-parent="hasActiviteParent"
        @majEffectifPrevisionnel="majEffectifPrevisionnel"
      />
      <footer class="columns is-vcentered ">
        <div class="column is-narrow">
          <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id }, query: { visu: visu } })">
            <b-button class="mt-button has-text-weight-semibold is-size-7 mt-button-fin " type="is-secondary" expanded>
              annuler
            </b-button>
          </nuxt-link>
        </div>
        <div class="column is-narrow">
          <b-button
            class="mt-button has-text-weight-semibold is-size-7 mt-button-fin "
            type="is-primary"
            native-type="submit"
            expanded
          >
            Enregistrer les modifications
          </b-button>
        </div>
      </footer>
      <mt-modal-ok :ouvert.sync="ouvertOK" @action="visualiser">
        L’activité a bien été modifiée.
      </mt-modal-ok>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtFormFieldsActivity from '~/components/activity/form-fields-activity';
import { newActivity, retourActivite } from '~/components/mixins/activityMixin';
import MtModalOk from '~/components/modal/mt-modal-ok';

export default {
  layout: 'container-small',
  components: {
    MtModalOk,
    MtPageTitle,
    MtFormFieldsActivity,
  },
  mixins: [retourActivite],
  data() {
    return {
      ouvertOK: false,
      ouvertDelete: false,
      ouvertOkDelete: false,
      commentaire: '',
    };
  },
  async asyncData(context) {
    const activite = Object.assign(newActivity(context.store), await context.$api.activites.get(context.params.id));
    let hasActiviteParent = false;
    let uniteParent = null;
    let unite = '';
    if (activite.idParent) {
      hasActiviteParent = true;
      const activiteParent = await context.$api.activites.getParent(context.params.id);
      uniteParent = activiteParent.organisme;
      const organismeParents = await context.$api.organisme(uniteParent.id).organismesByEnfantOrderByHierarchie();
      for (let i = 0; i < organismeParents.length; i += 1) {
        if (i !== organismeParents.length - 1) {
          unite += `${organismeParents[i].code} / `;
        } else {
          unite += `${organismeParents[i].code}`;
        }
      }
    }
    const visu = context.query && context.query.visu ? context.query.visu : null;
    const [nombrePax, effectifPrevisionnel] = await Promise.all([
      context.$api.activites.nombreDePax(activite.organisme.id),
      context.$api.organisme().disponibilitesComplete(activite.dateDebut.toISOString(), activite.dateFin.toISOString()),
    ]);
    return {
      effectifPrevisionnel,
      activite,
      visu,
      nombrePax,
      hasActiviteParent,
      uniteParent,
      unite,
    };
  },
  methods: {
    async submit() {
      await this.$api.activites.modifierPartiellement(this.activite.id, this.activite);
      try {
        this.ouvertOK = true;
      } catch ({
        response: {
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    visualiser() {
      this.$router.push(
        this.profilLink({ name: 'activites-id', params: { id: this.activite.id }, query: { visu: this.visu } }),
      );
    },
    async majEffectifPrevisionnel() {
      if (this.activite.dateDebut && this.activite.dateFin) {
        this.effectifPrevisionnel = await this.$api
          .organisme()
          .disponibilitesComplete(this.activite.dateDebut.toISOString(), this.activite.dateFin.toISOString());
      }
    },
    ajouterParticipant() {
      this.$router.push(
        this.profilLink({
          name: 'activites-id-participer',
          params: { id: this.activite.id },
          query: { visu: this.visu },
        }),
      );
    },
    dupliquer() {
      this.$router.push(
        this.profilLink({
          name: 'activites-id-dupliquer',
          params: { id: this.activite.id },
        }),
      );
    },
    retourAccueil() {
      this.$router.push(
        this.profilLink({
          name: this.page,
          query: { mois: this.queryMois },
        }),
      );
    },
    deleteActivite() {
      try {
        this.$api.activites.delete(this.activite.id, this.commentaire);
        this.ouvertOkDelete = true;
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.commentaire {
  text-align: initial;
}
</style>
